#define MIN(a, b) (((a) > (b)) ? (b) : (a))

//time
#define MAX_FRAME_LAG 1 //if there is a lag of longer than this many seconds second between frames, use this value
//sprites
#define SPRSZE 16
#define HLFSZE 8
#define SPRMAX 15
#define NUMSHIPS 2
#define SHIP_PLAYER 0
#define SHIP_CPU 1
#define BGCLR 0
#define BARCLR 200;
//shadow engine
#define SHADOWANG .5
#define SHADOWDIST 5
#define SHADOWRATE 256
#define SHADOWBLEND 5
#define MAXLIGHTS 64
#define AMBLIGHT 10 //by popular demand :] (try setting to 0 - the edges of the screen becone very dark)
#define STAR_LUX 512
//general physics
#define BOUNCERATIO .7 //speed ratio after bouncing off a wall
//weapon physics
#define MAXWEPSPEED 512 //pixels-per-sec
#define WEPSPEED 360 //pixels-per-sec added to ship speed
#define WEPSTARTDIST 9 //pixels, starts this far in front of the ship (so it won't hit the ship itself)
#define WEPDAMAGE 32 //shield units, taken off on collision
#define WEPRANGE 2 //sec, time until expires (int)
#define WEPRECHARGE 1 //sec, time until can fire again (int)
#define WEP_LUX 64 //byte, brightness of shot
#define MAXSHOTS MAXLIGHTS - 1 //maximum shots on screen
#define SHOT_COLOR 250 //byte, color of the shot
#define SHOT_IMPACT .6 //how many times the inertia of the shot moves the ship
//ship physics
#define MAXSPEED 128 //pixels-per-sec
#define MINSPEEDTOLERANCE 1 //below this speed the ship will stop
#define MAXSHIELDS 320 //shield unit count when full
#define ACCEL 128 //pixels-per-sec-per-sec
#define TURNRATE 256 //angle-per-sec, or rotations-per-sec * 256
#define SHIELDRECHARGE 1 //sec-per-shield unit increase
//game screen
#define MARGIN 5
#define LBOUND (-MARGIN)
#define RBOUND (SCRX + MARGIN)
#define HZONE (SCRX + (MARGIN * 2))
#define TBOUND (-MARGIN)
#define BBOUND (SCRY + MARGIN)
#define VZONE (SCRY + (MARGIN * 2))
//radian scale (how many 1/256-circle-degrees per radian) for improved conversion speed
#define RADIAN 40.743665431525208475704857846722006797791 // 128 / PI
//ai settings
#define AI_BEHIND 32
#define AI_TURN_TOLERANCE 8
#define AI_TOOCLOSE 64
#define AI_AIMERROR 32
#define AI_HLFAIMERROR (AI_AIMERROR >> 1)
