#include "meta.h"

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) {
	MSG Msg; //messages for the window
	BOOL multiplayer;

	//put here: a menu window and a loop through the game window (exit game returns to menu)

	InitMainWnd(); //register and display the window
	InitTrig(); //fill in trig lookup-tables

	{
		int result;

		result = MessageBox(hWnd, "To win, blow up everything that's not you.\n\nPlayer one controls: left, right, up, down, control\nPlayer two controls: a, d, w, s, space.\n\nFor more stuff, visit http://neil.freeshell.org/ or e-mail dreaded.neil@phreaker.net\n\nPlay with two players (otherwise play will be vs. the computer)?", "Cabalistic Void", MB_YESNOCANCEL | MB_ICONQUESTION | MB_TASKMODAL | MB_DEFBUTTON2);
		if(result == IDYES) multiplayer = TRUE;
		if(result == IDNO) multiplayer = FALSE;
		if(result == IDCANCEL) return 0;
	}
	{
		int currentwinner = -1;

		if(!(hWnd = CreateWindowEx(WS_EX_TOPMOST, WND_CLASS_NAME, WND_TITLE, WS_VISIBLE | WS_POPUP, 4, 4, SCRX, SCRY, NULL, NULL, hInst, NULL))) die("create main window");
		ShowWindow(hWnd, SW_NORMAL);
		UpdateWindow(hWnd);

		InitDD(); //start DirectDraw and create surfaces
		InitGame(); //set startup game state

		ddsd.dwSize = sizeof(DDSURFACEDESC);
		while(currentwinner == -1) {
			if(PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE)) {
				//if quit, break
	    	    if(Msg.message == WM_QUIT) break;
				//translate any accelerator keys
				TranslateMessage(&Msg);
				//send the message to the window proc
				DispatchMessage(&Msg);
			}
			else {
				if(SUCCEEDED(IDirectDrawSurface_Lock(lpddsBack, NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL))) {
					/* and have a pointer to video memory */
					screen_buffer = ddsd.lpSurface;
					/* erase what was on the back buffer */
					ZeroMemory(screen_buffer, SCRX * ddsd.lPitch);
					/* draw the graphics on the back buffer */
					IDirectDrawSurface_Lock(lpddsBack, NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WAIT, NULL);
					currentwinner = GameMain(multiplayer); /* FIXME: actually check for multiplayer */
					/* release the surface */
					IDirectDrawSurface_Unlock(lpddsBack, ddsd.lpSurface);
					/* flip it to the front */
					IDirectDrawSurface_Flip(lpddsPrimary, NULL, DDFLIP_WAIT);
				}
				else {
					/* there is no pointer to video memory */
					screen_buffer = NULL;
					/* the most likely cause is losing the pointer to the surface, i.e. from switchching to another app; try to fix it */
					IDirectDrawSurface_Restore(lpddsPrimary);
				}
			}
		}
		KillDD();
		ShowCursor(TRUE);
		Sleep(100); //players may still be holding down the trigger
		if(currentwinner != -1) {
			char note[512];

			if(currentwinner == 0) wsprintf(note, "Player one reigns victorious.");
			else if(currentwinner == 1 && multiplayer) wsprintf(note, "Player two reigns victorious.");
			else wsprintf(note, "The computer AI has won.");
			MessageBox(NULL, note, "Battle Report", MB_OK | MB_ICONEXCLAMATION);
		}
		DestroyWindow(hWnd);
	}
	return Msg.wParam;
}

void InitMainWnd(void) {
	WNDCLASSEX wc;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(NULL, MAKEINTRESOURCE(IDI_MAIN_ICON));
	wc.hIconSm = LoadIcon(NULL, MAKEINTRESOURCE(IDI_MAIN_ICON));
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(BLACK_BRUSH);//NULL;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = WND_CLASS_NAME;
	if(!(RegisterClassEx(&wc))) die("register main window");
}

int FAR PASCAL MainWndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
	if(Msg == WM_SETCURSOR) {
		ShowCursor(FALSE); //hide cursor
		return TRUE;
	}
	else if(Msg == WM_CREATE) {
		return TRUE;
	}
	else if(Msg == WM_KEYDOWN) {
		if(wParam == CTRL_EXIT) {
			DestroyWindow(hWnd);
		}
		return TRUE;
	}
	else if(Msg == WM_DESTROY) {
//		KillDD();
		//freeall
		PostQuitMessage(0);
		return TRUE;
	}
	else return DefWindowProc(hWnd, Msg, wParam, lParam);
}
