typedef unsigned char byte;

typedef struct {
	int x;
	int y;
} vec2_it;

typedef struct {
	float x;
	float y;
} vec2_t;

typedef struct {
	vec2_it p;
	int lux;
} light_t;

typedef struct {
	vec2_t p;
	byte r;
	vec2_t inertia;
	int shield;
	LONGLONG whenshoot;
	LONGLONG whenshield;
	//etc.
} ship_t;

typedef struct {
	int lightindex;
	vec2_t p;
	vec2_t inertia;
	LONGLONG whenexpires;
} shot_t;

typedef struct {
	int lightindex;
	vec2_it p;
	int size;
} boom_t;
